@echo off
	REM *************** Begin Standard Header - Do not add comments here ***************
	REM 
	REM 
	REM File Name: addLDAPUserToGroup.bat
	REM
	REM
	REM Licensed Materials - Property of IBM
    	REM
    	REM (C) Copyright IBM Corp. 2016  All Rights Reserved
    	REM
    	REM US Government Users Restricted Rights - Use, duplication, or
    	REM disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
	REM
	REM **************************** End Standard Header *******************************

	set WAS_HOME=%~1
	set SKLM_HOME=%~2
	set WAS_HOME=%WAS_HOME:\=\\%
	set SKLM_HOME=%SKLM_HOME:\=\\%
	set WAS_USER=%3
	set WAS_PASS=%4
	set USER_UNIQUE_NAME=%~5
	set SKLM_ADMIN=%6
	set SKLM_ADMIN_PASS=%7
	set mylog=sklmldapconf.log

	if %1X==-?X goto printUsage
	if %2X==X goto printUsage
	if %4X==X goto printUsage
	goto checkWAS_HOME

	:printUsage
	 echo addLDAPUserToGroup.bat [ WAS_HOME SKLM_INSTALL_HOME WAS_ADMIN WAS_PASS uid=001,c=in,ou=bluepages,o=ibm.com SKLM_ADMIN SKLM_ADMIN_PASS] ^| [-?]
	 echo  Configures SKLM with LDAP,  where 
	 echo   -? Returns this command usage
	 echo  WAS_HOME is the directory where WebSphere Application Server(WAS) for SKLM is installed. 
	 echo  SKLM_INSTALL_HOME is the directory where SKLM is installed.
	 echo  WAS_ADMIN is Username of WebSphere Application Server(WAS) for SKLM. 
	 echo  WAS_PASS is WAS_PASS of WebSphere Application Server(WAS) for SKLM.
	 echo  USER_UNIQUE_NAME is the LDAP user you want to provide SKLM Admin role.
  	 echo  SKLM_ADMIN is the administrator of the SKLM.
	 echo  SKLM_ADMIN_PASS is the password for SKLM Administrator

	 echo  Defaults: 
	 echo  Windows WAS_HOME location: C:\Program Files (x86)\IBM\WebSphere\AppServer
	 echo  Windows SKLM_INSTALL_HOME: C:\Program Files (x86)\IBM\SKLMV27
	 exit /B 0

	
	:checkWAS_HOME
	if Exist %WAS_HOME% (
	goto checkSKLM_INSTALL_HOME
	) else (
	echo  "Check %WAS_HOME% exists!"
	exit /B 3
	)
	
	:checkSKLM_INSTALL_HOME
	echo %SKLM_HOME%
	if Exist %SKLM_HOME% (
	goto continue1
	) else (
	echo  "Check %SKLM_HOME% exists!"
	exit /B 3
	)

	:continue1
	
	REM Add LDAP user to klmGUICLIAccessGroup and klmSecurityOfficerGroup, which needs SKLM Admin Access. 
	echo  %date% %time% >> %mylog% 2>&1

	call "%WAS_HOME%"/bin/wsadmin.bat -username %WAS_USER% -password %WAS_PASS% -lang jython -f "%SKLM_HOME%/bin/LDAPIntegration/addLDAPUserToGroup.py" %USER_UNIQUE_NAME% klmGUICLIAccessGroup >> %mylog% 2>&1

	if %errorlevel% NEQ 0 (
		echo "Aborting...Add LDAP user to klmGUICLIAccessGroup failed."
		echo "addLDAPUserToGrpGUICLI = FAIL" >> ldaplog.out
		exit /B 22	
	) 
	echo "addLDAPUserToGrpGUICLI = PASS" >> ldaplog.out

	
	call "%WAS_HOME%"/bin/wsadmin.bat -username %WAS_USER% -password %WAS_PASS% -lang jython -f "%SKLM_HOME%/bin/LDAPIntegration/addLDAPUserToGroup.py" %USER_UNIQUE_NAME% klmSecurityOfficerGroup >> %mylog% 2>&1

	if %errorlevel% NEQ 0 (
         echo "Aborting...Add LDAP user to klmSecurityOfficerGroup failed."
         echo "addLDAPUserToGrpSecOff = FAIL" >> ldaplog.out
		 exit /B 22	
	) 
	echo "addLDAPUserToGrpSecOff = PASS" >> ldaplog.out
	
