@echo off
	REM *************** Begin Standard Header - Do not add comments here ***************
	REM 
	REM 
	REM File Name: sklmLDAPConfigure.bat
	REM
	REM
	REM Licensed Materials - Property of IBM
    	REM
    	REM (C) Copyright IBM Corp. 2016  All Rights Reserved
    	REM
    	REM US Government Users Restricted Rights - Use, duplication, or
    	REM disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
	REM
	REM **************************** End Standard Header *******************************

	

	set WAS_HOME=%~1
	set WAS_PATH=%WAS_HOME%
	set SKLM_HOME=%~2
	set WAS_HOME=%WAS_HOME:\=\\%
	set SKLM_HOME=%SKLM_HOME:\=\\%
	set WAS_USER=%3
	set WAS_PASS=%4
	set SKLM_ADMIN=%5
	set SKLM_ADMIN_PASS=%6
	set DB_HOME=%~7
	set mylog=sklmldapconf.log

	if %1X==-?X goto printUsage
	if %2X==X goto printUsage
	if %4X==X goto printUsage
	goto checkWAS_HOME

	:printUsage
	 echo sklmLDAPConfigure.bat [ WAS_HOME SKLM_INSTALL_HOME WAS_ADMIN WAS_PASS SKLM_ADMIN SKLM_ADMIN_PASS DB_INSTALL_DIR] ^| [-?]
	 echo  Configures SKLM with LDAP,  where 
	 echo   -? Returns this command usage
	 echo  WAS_HOME is the directory where WebSphere Application Server(WAS) for SKLM is installed. 
	 echo  SKLM_INSTALL_HOME is the directory where SKLM is installed.
	 echo  WAS_ADMIN is Username of administrator of WebSphere Application Server(WAS) for SKLM. 
	 echo  WAS_PASS is WAS_PASS of WebSphere Application Server(WAS) for SKLM.
	 echo  SKLM_ADMIN is username of administrator for SKLM
	 echo  SKLM_ADMIN_PASS is the password for SKLM Administrator
	 echo  DB_INSTALL_DIR is the directory where DB2 for SKLM is installed

	 echo  Defaults: 
	 echo  Windows WAS_HOME location: C:\Program Files (x86)\IBM\WebSphere\AppServer
	 echo  Windows SKLM_INSTALL_DIR: C:\Program Files (x86)\IBM\SKLMV27
	 echo  Windows DB_INSTALL_DIR: C:\Program Files (x86)\IBM\DB2SKLMV27
	 exit /B 0

	
	:checkWAS_HOME
	if Exist %WAS_HOME% (
	goto checkSKLM_INSTALL_HOME
	) else (
	echo  "Check %WAS_HOME% exists!"
	exit /B 3
	)
	
	:checkSKLM_INSTALL_HOME
	if Exist %SKLM_HOME% (
	goto stopWAS
	) else (
	echo  "Check %SKLM_HOME% exists!"
	exit /B 3
	)
	
	:stopWAS
	xcopy /y "%DB_HOME%\java\db2jcc.jar" "%WAS_HOME%"\lib\
	xcopy /y "%DB_HOME%\java\db2jcc_license_cu.jar" "%WAS_HOME%"\lib\
	echo "STOPPING WAS.."
	echo "STOPPING WAS.." >> %mylog% 2>&1
	call "%WAS_HOME%"/profiles/KLMProfile/bin/stopServer.bat server1 -username %WAS_USER% -password %WAS_PASS% >> %mylog% 2>&1
	if %errorlevel% == 0 ( goto backupProfile ) else ( goto error )
	
		
	
	:backupProfile
	
	REM Back up KLMProfile.
	echo "BACKUP KLMProfile.."
	echo "BACKUP KLMProfile.." >> %mylog% 2>&1
	if exist "%WAS_PATH%\products\sklm\data\WASProfile_Backup" ( 
	del "%WAS_PATH%\products\sklm\data\WASProfile_Backup" 
	)
		
	call "%WAS_HOME%"/bin/manageprofiles.bat -backupProfile -profileName KLMProfile -backupFile "%WAS_HOME%/products/sklm/data/WASProfile_Backup" >> %mylog% 2>&1
	if %errorlevel% == 0 ( 
	echo "ProfileBackup = PASS" > ldaplog.out 
	goto startWAS
	) 
	echo "Aborting...Backup Profile failed."
	echo "ProfileBackup = FAIL" > ldaplog.out
	goto error 
	
		
	:startWAS
	echo "STARTING WAS.."
	echo "STARTING WAS.." >> %mylog% 2>&1
	call "%WAS_HOME%"/profiles/KLMProfile/bin/startServer.bat server1 >> %mylog% 2>&1
	if %errorlevel% == 0 ( goto continue1 ) else ( goto error )
	
	:continue1
	REM TAKE SKLM DATA BACKUP 
	echo "SKLM Backup started"
	echo "SKLM Backup started" >> %mylog% 2>&1
	call "%WAS_HOME%"/bin/wsadmin.bat -username %SKLM_ADMIN% -password %SKLM_ADMIN_PASS% -lang jython -c "print AdminTask.tklmBackupRun('[-backupDirectory \"%WAS_HOME%\\products\\sklm\data\" -password passw0rd]')" >> %mylog% 2>&1

	if %errorlevel% NEQ 0 (
		echo "Aborting...SKLM backup failed."
		echo "SKLMBackup = FAIL" >> ldaplog.out
		goto error
	) 
	echo "SKLMBackup = PASS" >> ldaplog.out
	echo "SKLM Backup Finished"
	

	REM Configure LDAP Server
	REM ------------------------------------------------
	echo "Start SKLM LDAP Configuration.."
	echo "Start SKLM LDAP Configuration.." >> %mylog% 2>&1
	call "%WAS_HOME%"/bin/wsadmin.bat -username %WAS_USER% -password %WAS_PASS% -lang jython -f "%SKLM_HOME%/bin/LDAPIntegration/configureLDAPServer.py" >> %mylog% 2>&1

	if %errorlevel% NEQ 0 (
		echo "Aborting...SKLM LDAP server configuration failed."
		echo "SKLMConfLDAP = FAIL" > ldaplog.out
		goto error
	) 
	echo "SKLMConfLDAP = PASS" >> ldaplog.out
	echo "LDAP basic configuration done"
	

	REM ------------------------------------------------

	REM RESTART WAS ..
	REM -------------------------------------------------
	echo "Restarting WAS..."
	echo "Restarting WAS..." >> %mylog% 2>&1
	call "%WAS_HOME%"/profiles/KLMProfile/bin/stopServer.bat server1 -username %WAS_USER% -password %WAS_PASS% >> %mylog% 2>&1
	if %errorlevel% NEQ 0 (
		echo "Aborting...WebSphere stop failed."
		echo "WebSphere Service stop failed"
		goto error
	) 
	call "%WAS_HOME%"/profiles/KLMProfile/bin/startServer.bat server1 >> %mylog% 2>&1
	if %errorlevel% NEQ 0 (
		echo "Aborting...WebSphere start failed."
		echo "WebSphere Service start failed"
		goto error
	) 
	REM --------------------------------------------------

	REM REMOVE GROUPS FROM FILE BASED REPOSITORY
	REM -----------------------------------------------------
	echo "Removing Groups from File Based Repository.."
	echo "Removing Groups from File Based Repository.." >> %mylog% 2>&1
	call "%WAS_HOME%"/bin/wsadmin.bat -username %WAS_USER% -password %WAS_PASS%  -lang jython -f "%SKLM_HOME%/bin/LDAPIntegration/removeGroupsFromDefRepos.py" >> %mylog% 2>&1
	if %errorlevel% NEQ 0 (
		echo "Aborting...Removing groups from file based repository failed."
		echo "RemGrpFileRep = FAIL" >> ldaplog.out
		goto error
	) 
	echo "RemGrpFileRep = PASS" >> ldaplog.out
	echo "Groups from File Based Repository removed"
	

	REM -----------------------------------------------------


	REM Modify Security Role to User/group mapping to remove the administrator role mapping to klmGUICLIAccessGroup 
	REM ----------------------------------------------------------
	echo "Modify Security Role to User/group mapping to remove the administrator role mapping to klmGUICLIAccessGroup.."
	echo "Modify Security Role to User/group mapping to remove the administrator role mapping to klmGUICLIAccessGroup.." >> %mylog% 2>&1
	call "%WAS_HOME%"/bin/wsadmin.bat -username %WAS_USER% -password %WAS_PASS% -lang jython -f "%SKLM_HOME%/bin/LDAPIntegration/removeSecurityRoleMapping.py" >> %mylog% 2>&1
	if %errorlevel% NEQ 0 (
		echo "Aborting...Modify Security Role to User/group mapping to remove the administrator role mapping to klmGUICLIAccessGroup failed."
		echo "RemAdminRoleMapping = FAIL"  >> ldaplog.out
		goto error
	) 
	echo "RemAdminRoleMapping = PASS"  >> ldaplog.out
	echo "Administrator role mapping removed"
	

	REM ----------------------------------------------------------


	REM RESTART WAS 
	REM ---------------------------------------------------------
	echo "Restarting WAS..."
	echo "Restarting WAS..." >> %mylog% 2>&1
	call "%WAS_HOME%"/profiles/KLMProfile/bin/stopServer.bat server1 -username %WAS_USER% -password %WAS_PASS% >> %mylog% 2>&1
	if %errorlevel% NEQ 0 (
		echo "Aborting...WebSphere stop failed."
		echo "WebSphere Service stop failed"
		goto error
	) 

	call "%WAS_HOME%"/profiles/KLMProfile/bin/startServer.bat server1 >> %mylog% 2>&1
	if %errorlevel% NEQ 0 (
		echo "Aborting...WebSphere start failed."
		echo "WebSphere Service start failed"
		goto error
	) 
	REM ----------------------------------------------------------

	REM Add the SKLM Application groups to database based repository
	REM ------------------------------------------------------------
	echo "Add the SKLM Application groups to database based repository.."
	echo "Add the SKLM Application groups to database based repository.." >> %mylog% 2>&1
	call "%WAS_HOME%"/bin/wsadmin.bat -username %WAS_USER% -password %WAS_PASS% -lang jython -f "%SKLM_HOME%/bin/LDAPIntegration/addGroupsToDBRepos.py" >> %mylog% 2>&1
	if %errorlevel% NEQ 0 (
		echo "Aborting...Add SKLM Application groups to DB repository failed."
		echo "AddGrpDBRepos = FAIL"  >> ldaplog.out
		goto error
	) 
	echo "AddGrpDBRepos = PASS"  >> ldaplog.out
	echo "Added SKLM Application groups to database repository"
	

	REM -------------------------------------------------------------


	REM update the WAS federated repository with LDAP repository 
	REM -----------------------------------------------------------
	echo "update the WAS federated repository with LDAP repository.."
	echo "update the WAS federated repository with LDAP repository.." >> %mylog% 2>&1
	call "%WAS_HOME%"/bin/wsadmin.bat -username %WAS_USER% -password %WAS_PASS% -lang jython -f "%SKLM_HOME%/bin/LDAPIntegration/updateLDAPReposConfig.py" myldap >> %mylog% 2>&1
	if %errorlevel% NEQ 0 (
		echo "Aborting...updating WAS repository with LDAP respository failed."
		echo "UpdLDAPReposConf = FAIL"  >> ldaplog.out
		goto error
	) 
	echo "UpdLDAPReposConf = PASS"  >> ldaplog.out
	echo "Updated WAS federated repository with LDAP repository"
	

	REM ------------------------------------------------------------


	REM Add Security Role to User/group mapping and map administrator role to klmGUICLIAccessGroup 
	REM -------------------------------------------------------------------------------------------
	echo "Add Security Role to User/group mapping and map administrator role to klmGUICLIAccessGroup .."
	echo "Add Security Role to User/group mapping and map administrator role to klmGUICLIAccessGroup .." >> %mylog% 2>&1
	call "%WAS_HOME%"/bin/wsadmin.bat -username %WAS_USER% -password %WAS_PASS% -lang jython -f "%SKLM_HOME%/bin/LDAPIntegration/assignSecurityRoleMapping.py" >> %mylog% 2>&1
	if %errorlevel% NEQ 0 (
		echo "Aborting...Add Security Role to User/group mapping and map administrator role to klmGUICLIAccessGroup failed."
	        echo "AssSecRoleMapping = FAIL"  >> ldaplog.out
			goto error
	) 
	echo "AssSecRoleMapping = PASS"  >> ldaplog.out
	echo "Administrator role mapping done"
	

	REM -------------------------------------------------------------------------------------------	


	REM RESTART WAS 
	REM -------------------------------------------------------------------------------------------
	echo "Restarting WAS..."
	echo "Restarting WAS..." >> %mylog% 2>&1
	call "%WAS_HOME%"/profiles/KLMProfile/bin/stopServer.bat server1 -username %WAS_USER% -password %WAS_PASS% >> %mylog% 2>&1
	if %errorlevel% NEQ 0 (
		echo "Aborting...WebSphere stop failed."
		echo "WebSphere Service stop failed"
		goto error
	) 

	call "%WAS_HOME%"/profiles/KLMProfile/bin/startServer.bat server1 >> %mylog% 2>&1
	if %errorlevel% NEQ 0 (
		echo "Aborting...WebSphere stop failed."
		echo "WebSphere Service start failed"
		goto error
	) 
	REM -------------------------------------------------------------------------------------------

	:error
	exit /B 20

	:END