@echo off
rem #########################################################
rem #
rem #       EDIT THE PARAMETER VALUE IN THIS SECTION
rem #
rem tiphome : Required, the home directory of Tivoli Integrated Portal
rem username : Required, the username of the Tivoli Key Lifecycle Manager user with klmBackup permission
rem password : Required, the password for the Tivoli Key Lifecycle Manager user to login
rem backuppw : Required, the password used for backup operation
rem backupdes : Optional, description of the Tivoli Key Lifecycle Manager backup
rem backupdir : Optional, full path to the directory, where the backup jar file is to be stored
rem backupDBdir : Optional, full path to the directory, where the database backup is to be stored

rem NOTE: For all directory values, please do NOT use "\"

Set tiphome=
Set username=
Set password=
Set backuppw=
Set backupdes=
Set backupdir=
Set backupDBdir=
rem #########################################################


rem #########################################################
rem #   
rem #       DO NOT MAKE CHANGES BELOW THIS LINE
rem #   
rem #########################################################
Set backupparams=
Set backupresult=

if not defined tiphome (
echo Tivoli Integrated Portal home directory is not specified.
Set backupresult=104
goto end
)
if not defined username (
echo Tivoli Key Lifecycle Manager username is not specified.
Set backupresult=104
goto end
)
if not defined password (
echo Tivoli Key Lifecycle Manager password is not specified.
Set backupresult=104
goto end
)
if not defined backuppw (
echo Backup password is not specified.
Set backupresult=104
goto end
)

if defined backupdes (
set backupparams=%backupparams% -description "%backupdes%"
)

if defined backupdir (
set backupparams=%backupparams% -backupDirectory "%backupdir%"
)

if defined backupDBdir (
set backupparams=%backupparams% -databaseBackupDirectory "%backupDBdir%"
)

call %tiphome%/bin/wsadmin.bat -username "%username%" -password "%password%" -lang jython -f "%~dp0/autobackup.py" "%backuppw%" %backupparams%
Set backupresult=%errorlevel%

if %backupresult%==0 (
echo Backup is successful.
goto end
)

if %backupresult%==1 (
echo Tivoli Integrated Portal home directory is incorrect.
goto end
)

if %backupresult%==2 (
echo Backup is partially successful.
goto end
)

if %backupresult%==3 (
echo Backup is not needed.
goto end
)

if %backupresult%==4 (
echo Backup is running. No backup is created by this script.
goto end
)

if %backupresult%==101 (
echo Backup is unsuccessful.
goto end
)

if %backupresult%==102 (
echo Backup result is unknown.
goto end
)

if %backupresult%==103 (
echo Exception in auto backup process. No backup is created.
goto end
)

if %backupresult%==105 (
echo Login to Tivoli Key Lifecycle Manager failed.
goto end
)

:end
echo Auto backup result status : %backupresult%

rem Auto backup result status
rem 0 : backup is successful
rem 1 : Tivoli Integrated Portal home directory is incorrect
rem 2 : backup is partially successful
rem 3 : backup is not needed
rem 4 : backup is running
rem 101 : backup is unsuccessful
rem 102 : backup result is unknown
rem 103 : exception during auto backup process
rem 104 : script error, missing required parameter etc
rem 105 : login failed

@echo on