@echo OFF
REM
REM Licensed Materials-Property of IBM
REM (C)Copyright IBM Corp 2008
REM All rights reserved
REM US Government Users Restricted Rights
REM Use, duplication, or disclosure restricted
REM by GSA ADP Schedule Contract with IBM Corp
REM
REM  arg1 -  log  -   log file to be used by this script 
REM  arg2 -  instance  -  instance name (for example db2inst2) 
REM  arg3 -  dbname  -  database name
REM  arg4 -  dbbackupdir
REM  REM   Note:  The batch file
REM 	        must be run on the same machine where DB2 server is installed.
REM 		
REM ----------------------------------------------------------------------------

setlocal


set LOG=%~s1
REM Set DB2INSTANCE environment variable 
set DBINST=%2
set DBNAME=%3
set DBBACKUPDIR=%4
set RC=0
SET DB2INSTANCE=%DBINST%
echo ---------------------------------------------------------------------------------------------- >> "%LOG%" 
echo Started executing dbmigbackup.bat >> "%LOG%" 
echo ---------------------------------------------------------------------------------------------- >> "%LOG%" 
SET TRANSLOGDRIVE=C:
if not exist %SYSTEMDRIVE%\tklmV2properties\db2srcit.txt goto nosrcit

for /f "tokens=1,2,3 delims==" %%a in (%SYSTEMDRIVE%\tklmV2properties\db2srcit.txt) do (

  if "%%a"=="INSTANCEHOME" set TRANSLOGDRIVE=%%b
  if "%%a"=="DB2INSTALLDIR" set DB2DIR=%%b
  )

:nosrcit
echo %TRANSLOGDRIVE% >> "%LOG%"

REM directory where scripts and response files have been written
set CURRENT_DIR=.

echo db2 stop database manager force >> "%LOG%"
db2 stop database manager force >> "%LOG%"

echo db2 start database manager >> "%LOG%"
db2 start database manager >> "%LOG%"

echo db2 list applications >> "%LOG%"
db2 list applications >> "%LOG%"

echo db2 backup db %DBNAME% to %DBBACKUPDIR% >> "%LOG%"
db2 backup db %DBNAME% to %DBBACKUPDIR% >> "%LOG%"

set RC=%ERRORLEVEL%
if %RC% LSS 0 goto ERROR
if %RC% LSS 4 set RC=0 
if not %RC%==0 goto ERROR
set RESTOREDONE=1

goto END

:ERROR

REM NO SPECIAL PROCESSING NEEDED
:END



echo Return=%RC%
if %RC%==0 echo Return=%RC% >> "%LOG%"
if %RC% neq 0 echo Return %RC% >> "%LOG%"


echo ---------------------------------------------------------------------------------------------- >> "%LOG%" 
exit %RC%
endlocal
